import requests
import json
import sys
import time


def executeGrayification():
    url = "http://divaservices.unifr.ch/api/v2/enhancement/grayification/1"

    payload = " {\"parameters\":{},\"data\":[{\"inputImage\": \"testCollection/ubb-A-II-0004_0002r.jpeg\"}]}"
    headers = {'content-type': 'application/json'}

    response = json.loads(requests.request("POST", url, data=payload, headers=headers).text)
    result = pollResult(response['results'][0]['resultLink'])
    print("Result Image available at: " + result['output'][0]['file']['url'])


def pollResult(result_link):
    """ Polls for the result of the execution in 1s intervals 
    Arguments:
        result_link {string} -- [the resultLink generated by the POST request that started the execution]
        
    Returns:
        [json] -- [the result of the execution]
    """

    response = json.loads(requests.request("GET", result_link).text)
    while(response['status'] != 'done'):
        if(response['status'] == 'error'):
            sys.stderr.write('Error in executing the request. See the log file at: ' + response['output'][0]['file']['url'])
            sys.exit()
        time.sleep(1)
        response = json.loads(requests.request("GET", result_link).text)
    return response

executeGrayification()